<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use common\models\Card;
use common\models\Customer;
use common\models\Ticket;
use common\models\Account;
use yii\web\UploadedFile;
use common\components\giro\GiroDETSTA;
use common\models\Ugiro;
use common\components\giro\GiroDETSTAFej;
use common\components\giro\GiroDETSTALab;
use common\components\giro\GiroDETSTATetel;

/**
 * ContactForm is the model behind the contact form.
 * @property \Yii\web\UploadedFile $file
 */
class CardImportRfidForm extends Model{


	public $id_giro;
	public $uzenet;
	public $detstatUzenet;
	
	public function rules(){
		return [
				[['id_giro'], 'safe']

		];
	}
	
	
	public function run(){
		
		$ugiro = Ugiro::findOne($this->id_giro);
		$requests = $ugiro->requests;
		
		$this->detstatUzenet = new GiroDETSTA();
		
		$fej = new GiroDETSTAFej();
		$fej->csoportosUzenetSorszam->osszeallitasDatuma = $ugiro->datum;
		$fej->csoportosUzenetSorszam->sorszam = $ugiro->number;
		$fej->detstaUzenetSorszam->osszeallitasDatuma = $ugiro->datum;
		$fej->detstaUzenetSorszam->sorszam = $ugiro->number;
		$fej->ido = "141414";
		$fej->jelentesJelzo = "8";
		$fej->kezdemenyezoAzonosito = \Yii::$app->params['ugiro_kezdemenyezo_azonosito'];
		$fej->kezdemenyezoBankszamla = \Yii::$app->params['ugiro_kezdemenyezo_szamlaszam'];
		
		$this->detstatUzenet->fej = $fej;
		
		foreach ($requests as $request){
			$tetel = new GiroDETSTATetel();
			$tetel->tetelSorszam = $request->number;
			$tetel->osszeg = $request->money;
			$tetel->eredetiTetelElszamolasiDatuma = date('Ymd');
			$tetel->visszajelzesInformacio = "00";
			$tetel->feldolgozasDatum = date('Ymd');
			$tetel->terhelesiDatum = date('Ymd');
			$tetel->eredetiHivatkozasiKod = "abc123";
			$tetel->ugyfelAzonosito = $request->id_customer;
		
			$this->detstatUzenet->tetelek[] = $tetel;
		}
		
		$lab = new GiroDETSTALab();
		$lab->teljesitettTetelekSzama = 0;
		$lab->teljesitettTetelekOsszerteke = 0;
		$lab->megNemValaszoltTetelekOsszerteke = 0;
		$lab->megNemValaszoltTetelekSzama = 0;
		$lab->visszautasitottTetelekOsszerteke = 0;
		$lab->visszautasitottTetelekSzama = 0;
		
		$this->detstatUzenet->lab = $lab;
		
		
		$this->uzenet = $this->detstatUzenet->toString();
	}


}